尚學堂【官網】-西安Java培訓|c++培訓|Android培訓|安卓培訓|java視頻教程|軟件工程師|-西安雁塔尚學堂計算機學校
常見問題  尚學堂首頁新聞公告常見問題

Java程序異常處理的特殊情況

www.zyopwk.live 發布人:java  |  來自:本站  |  發布時間:2017-09-19 16:42:00  |  點擊次數:2815

  1、不能在finally塊中執行return,continue等語句,否則會把異常“吃掉”;

  2、在try,catch中如果有return語句,則在執行return之前先執行finally塊。

  請大家仔細看下面的例子:

  以下是調用片段例子:

  public class TryTest {  public static void main(String[] args) {  try {  System.out.println(TryTest.test());// 返回結果為true其沒有任何異常  } catch (Exception e) {  System.out.println("Exception from main");  e.printStackTrace();  }  doThings(0);  }  public static boolean test() throws Exception {  try {  throw new Exception("Something error");// 第1步.拋出異常  } catch (Exception e) {// 第2步.捕獲的異常匹配(聲明類或其父類),進入控制塊  System.out.println("Exception from e");// 第3步.打印  return false;// 第5步. return前控制轉移到finally塊,執行完后再返回(這一步被吃掉了,不執行)  } finally {  return true; // 第4步. 控制轉移,直接返回,吃掉了異常  }  }  public static void doThings(int i)  {  try  {  if(i==0)  {  //在執行return之前會先執行finally  return;  }  int t=100/i;  System.out.println(t);  }catch(Exception ex)  {  ex.printStackTrace();  }  finally  {  System.out.println("finally");  }  }  }  
當前文:Java程序異常處理的特殊情況
上一頁:未來前景最好的IT專業
下一頁:【Android開發】Android進程及其生命周期
在線報名(*為必填項)
云南快乐十分开奖走势图